import app
from sdl2 import *
import sdl2.ext as s2ext

def createWindow(title,w,h):
	global window, renderer, width, height
	width = w
	height = h
	SDL_Init(SDL_INIT_VIDEO)
	window = SDL_CreateWindow(title.encode("utf-8"),SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED,w,h,SDL_WINDOW_RESIZABLE)
	renderer = SDL_CreateRenderer(window,-1,0) # SDL_RENDERER_ACCELERATED

def setColor(r,g,b,a):
	SDL_SetRenderDrawColor(renderer,r,g,b,a)

def drawPixel(x,y):
	SDL_RenderDrawPoint(renderer,x,y)

def clear():
	SDL_RenderClear(renderer)

def sleep(t):
	SDL_Delay(t)

def getEvents():
	events = s2ext.get_events()
	for event in events:
		if event.type == SDL_QUIT:
			yield "quit",[],{}
			continue
		
		if event.type == SDL_MOUSEMOTION:
			yield "mouse.move",[event.motion.x,event.motion.y],{}
			continue
		
		if event.type in [SDL_MOUSEBUTTONDOWN,SDL_MOUSEBUTTONUP]:
			button = event.button.button
			if button == 1: button = "left"
			if button == 2: button = "middle"
			if button == 3: button = "right"
		
		if event.type == SDL_MOUSEBUTTONDOWN:
			yield "mouse.down",[button],{}
			continue
		
		if event.type == SDL_MOUSEBUTTONUP:
			yield "mouse.up",[button],{}
			continue
		
		if event.window.event == SDL_WINDOWEVENT_RESIZED:
			yield "resized",[width,height],{}
			continue

def render():
	global renderer
	SDL_RenderPresent(renderer)

def quit():
	SDL_Quit()
